// TODO: Simplify this so that things are executed on change page and on first
// load look below at function doc strings

// one interaction can have more than one type when the associatee callback
// can be executed

class Interaction {
  constructor(htmlId="",
              checkStatus=true,
              disabledBefore=true,
              disabledAfter=false,
              hideBefore=true,
              hideAfter=false) {
    this.htmlId = htmlId;
    this.element = ((htmlId) => {
      document.getElementById(htmlId);
    })()
    this.checkStatus = checkStatus;
    this.callbacks = {};
    this.disabledBefore = disabledBefore;
    this.disabledAfter = disabledAfter;
    this.hideBefore = hideBefore;
    this.hideAfter = hideAfter;
  }

  setCallback(trigger, callback, bindThis, args=[]) {
    this.callbacks[trigger] = {
                                 "function": callback,
                                 "bindThis": bindThis,
                                 "args": args
                              };
  }

  bindThisToCallback(trigger) {
    let callback = this.callbacks[trigger];
    let boundedCallback = callback["function"].bind(callback.bindThis);
    return boundedCallback;
  }
}

class Interactions {
  constructor() {
    this.interactions = [];
  }

  addInteractions (interactions) {
    this.interactions.push(...interactions);
  }

  /**
   * This function executes all registered interactions of the type
   * onElementChange.
   * Interactions and their associated callbacks will be executed every time
   * a chante event occurs on the specified element.
   */
  onElementChangeExecute() {
    // checks if a change for every interactionElement happens and executes
    // the callbacks accordingly
    for (let interaction of this.interactions) {
      if (interaction.checkStatus) {
        interaction.element.addEventListener("change", (event) => {
          if (event.target.checked) {
            let f_on = interaction.bindThisToCallback("on");
            let args_on = interaction.callbacks.on.args;
            f_on(...args_on);
          } else if (!event.target.checked){
            let f_off = interaction.bindThisToCallback("off");
            let args_off = interaction.callbacks.off.args;
            f_off(...args_off);
          }
        });
      } else {
        continue
      }
    };
  }

  /**
   * This function executes all registered interactions of the type onQueryLoad.
   * Interactions and their associated callbacks will be executed once if when
   * the first query results of a query request are being displayed.
   */
  onQueryLoadExecute() {
  }

  /**
   * This function executes all registered interactions of the type
   * onPageChange.
   * Interactions and their associated callbacks will be executed everytime if
   * the user used the page navigation and a new result page is being displayed.
   */
  onPageChangeExecute() {
  }
}

// export Classes
export { InteractionElement, InteractionElements };